
<!doctype html>
<html lang="es" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
      <link rel="icon" href="../../assets/images/logo.png">
      <meta name="generator" content="mkdocs-1.3.0, mkdocs-material-8.3.9">
    
    
      
        <title>Diseño de Algoritmos - Programación en Java</title>
      
    
    
      <link rel="stylesheet" href="../../assets/stylesheets/main.1d29e8d0.min.css">
      
        
        <link rel="stylesheet" href="../../assets/stylesheets/palette.cbb835fc.min.css">
        
          
          
          <meta name="theme-color" content="#ef5552">
        
      
      
    
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
    <script>__md_scope=new URL("../..",location),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
  </head>
  
  
    
    
    
    
    
    <body dir="ltr" data-md-color-scheme="" data-md-color-primary="red" data-md-color-accent="cyan">
  
    
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#diseno-de-algoritmos" class="md-skip">
          Saltar a contenido
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

<header class="md-header" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Cabecera">
    <a href="../.." title="Programación en Java" class="md-header__button md-logo" aria-label="Programación en Java" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M22 9V7h-2V5a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-2h2v-2h-2v-2h2v-2h-2V9h2m-4 10H4V5h14v14M6 13h5v4H6v-4m6-6h4v3h-4V7M6 7h5v5H6V7m6 4h4v6h-4v-6Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            Programación en Java
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              Diseño de Algoritmos
            
          </span>
        </div>
      </div>
    </div>
    
    
    
      <label class="md-header__button md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Búsqueda" placeholder="Búsqueda" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" aria-label="Limpiar" tabindex="-1">
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Inicializando búsqueda
          </div>
          <ol class="md-search-result__list"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
  </nav>
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
          
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


<nav class="md-nav md-nav--primary" aria-label="Navegación" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="../.." title="Programación en Java" class="md-nav__button md-logo" aria-label="Programación en Java" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M22 9V7h-2V5a2 2 0 0 0-2-2H4a2 2 0 0 0-2 2v14a2 2 0 0 0 2 2h14a2 2 0 0 0 2-2v-2h2v-2h-2v-2h2v-2h-2V9h2m-4 10H4V5h14v14M6 13h5v4H6v-4m6-6h4v3h-4V7M6 7h5v5H6V7m6 4h4v6h-4v-6Z"/></svg>

    </a>
    Programación en Java
  </label>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
      

  
  
  
    <li class="md-nav__item">
      <a href="../.." class="md-nav__link">
        Principal
      </a>
    </li>
  

    
      
      
      

  
  
    
  
  
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_2" type="checkbox" id="__nav_2" checked>
      
      
      
      
        <label class="md-nav__link" for="__nav_2">
          Conceptos Generales
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Conceptos Generales" data-md-level="1">
        <label class="md-nav__title" for="__nav_2">
          <span class="md-nav__icon md-icon"></span>
          Conceptos Generales
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../lenguajes/" class="md-nav__link">
        Lenguajes de Programación
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../conceptos/" class="md-nav__link">
        Conceptos de Programación
      </a>
    </li>
  

            
          
            
              
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" data-md-toggle="toc" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          Diseño de Algoritmos
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        Diseño de Algoritmos
      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Tabla de contenidos">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Tabla de contenidos
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#resolucion-de-problemas" class="md-nav__link">
    Resolución de Problemas
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#analisis-del-problemas" class="md-nav__link">
    Análisis del Problemas
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#diseno-de-algoritmos_1" class="md-nav__link">
    Diseño de Algoritmos
  </a>
  
    <nav class="md-nav" aria-label="Diseño de Algoritmos">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#escritura-de-un-algoritmo" class="md-nav__link">
    Escritura de un Algoritmo
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#representacion-grafica-de-un-algoritmo" class="md-nav__link">
    Representación Gráfica de un Algoritmo
  </a>
  
    <nav class="md-nav" aria-label="Representación Gráfica de un Algoritmo">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#diagrama-de-flujo" class="md-nav__link">
    Diagrama de Flujo
  </a>
  
    <nav class="md-nav" aria-label="Diagrama de Flujo">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#simbolos-basicos" class="md-nav__link">
    Símbolos Básicos
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#simbolos-extras" class="md-nav__link">
    Símbolos Extras
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#pseudocodigo" class="md-nav__link">
    Pseudocódigo
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#software" class="md-nav__link">
    software
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../EstructurasControl/" class="md-nav__link">
        Estructuras de Control
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../EstructuraPrograma/" class="md-nav__link">
        Estructura de un programa
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../Instalaci%C3%B3n/" class="md-nav__link">
        Instalación IDE JAVA
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_3" type="checkbox" id="__nav_3" >
      
      
      
      
        <label class="md-nav__link" for="__nav_3">
          Estructuras de un Programa Java
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Estructuras de un Programa Java" data-md-level="1">
        <label class="md-nav__title" for="__nav_3">
          <span class="md-nav__icon md-icon"></span>
          Estructuras de un Programa Java
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/introJava/" class="md-nav__link">
        Introducción a Java
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/variables/" class="md-nav__link">
        Variables
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/operadores/" class="md-nav__link">
        Asignación y Operadores Java
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/entradasalida/" class="md-nav__link">
        Entrada/Salida
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/control/" class="md-nav__link">
        Estructuras de Control
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../estructuras/excepcion/" class="md-nav__link">
        Manejo de Excepciones
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_4" type="checkbox" id="__nav_4" >
      
      
      
      
        <label class="md-nav__link" for="__nav_4">
          Sintaxis
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Sintaxis" data-md-level="1">
        <label class="md-nav__title" for="__nav_4">
          <span class="md-nav__icon md-icon"></span>
          Sintaxis
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../sintaxis/sintaxis/" class="md-nav__link">
        Sintaxis Java
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../sintaxis/primitivos/" class="md-nav__link">
        Tipos de Datos
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../sintaxis/metodos/" class="md-nav__link">
        Metodos en Java
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../sintaxis/ClasesObjetos/" class="md-nav__link">
        Clases y Objetos
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_5" type="checkbox" id="__nav_5" >
      
      
      
      
        <label class="md-nav__link" for="__nav_5">
          Programación Orientada a Objetos
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Programación Orientada a Objetos" data-md-level="1">
        <label class="md-nav__title" for="__nav_5">
          <span class="md-nav__icon md-icon"></span>
          Programación Orientada a Objetos
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/arreglos/" class="md-nav__link">
        Arreglos
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/metodos/" class="md-nav__link">
        Metodos/Funciones
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/metodosEspeciales/" class="md-nav__link">
        Funciones especiales
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/container/" class="md-nav__link">
        ContainerClass
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/clases/" class="md-nav__link">
        Clases
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/herencia/" class="md-nav__link">
        Herencia
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/interfaces/" class="md-nav__link">
        Interfaces
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/polimorfismo/" class="md-nav__link">
        Polimorfismo
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/privacidad/" class="md-nav__link">
        Privacidad
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/persistencia/" class="md-nav__link">
        Persistencia
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/unitTest/" class="md-nav__link">
        UnitTest
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/enum/" class="md-nav__link">
        Enum
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../poo/record/" class="md-nav__link">
        Record
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_6" type="checkbox" id="__nav_6" >
      
      
      
      
        <label class="md-nav__link" for="__nav_6">
          Manejor de Archivos
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Manejor de Archivos" data-md-level="1">
        <label class="md-nav__title" for="__nav_6">
          <span class="md-nav__icon md-icon"></span>
          Manejor de Archivos
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../file/txt/" class="md-nav__link">
        Archivos de texto
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../file/json/" class="md-nav__link">
        json
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../file/csv/" class="md-nav__link">
        CSV
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_7" type="checkbox" id="__nav_7" >
      
      
      
      
        <label class="md-nav__link" for="__nav_7">
          Hilos
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Hilos" data-md-level="1">
        <label class="md-nav__title" for="__nav_7">
          <span class="md-nav__icon md-icon"></span>
          Hilos
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../hilos/thread/" class="md-nav__link">
        Thread
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_8" type="checkbox" id="__nav_8" >
      
      
      
      
        <label class="md-nav__link" for="__nav_8">
          Diagramas UML
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Diagramas UML" data-md-level="1">
        <label class="md-nav__title" for="__nav_8">
          <span class="md-nav__icon md-icon"></span>
          Diagramas UML
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../UMLDiagramaClases/introUML/" class="md-nav__link">
        Introducción a UML
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../UMLDiagramaClases/clases/" class="md-nav__link">
        Diagrama de Clases
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../UMLDiagramaClases/relaciones/" class="md-nav__link">
        Relaciones diagrama de clases
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
      
      
      

  
  
  
    
    <li class="md-nav__item md-nav__item--nested">
      
      
        <input class="md-nav__toggle md-toggle" data-md-toggle="__nav_9" type="checkbox" id="__nav_9" >
      
      
      
      
        <label class="md-nav__link" for="__nav_9">
          Herramientas
          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <nav class="md-nav" aria-label="Herramientas" data-md-level="1">
        <label class="md-nav__title" for="__nav_9">
          <span class="md-nav__icon md-icon"></span>
          Herramientas
        </label>
        <ul class="md-nav__list" data-md-scrollfix>
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/BlueJ/" class="md-nav__link">
        BlueJ
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/NetBeans/" class="md-nav__link">
        NetBeans
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/eclipse/" class="md-nav__link">
        Eclipse
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/intellij/" class="md-nav__link">
        Intellij
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/jshell/" class="md-nav__link">
        jShell
      </a>
    </li>
  

            
          
            
              
  
  
  
    <li class="md-nav__item">
      <a href="../../herramientas/jupyter/" class="md-nav__link">
        Jupyter
      </a>
    </li>
  

            
          
        </ul>
      </nav>
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
              
              <div class="md-sidebar md-sidebar--secondary" data-md-component="sidebar" data-md-type="toc" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    

<nav class="md-nav md-nav--secondary" aria-label="Tabla de contenidos">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Tabla de contenidos
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#resolucion-de-problemas" class="md-nav__link">
    Resolución de Problemas
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#analisis-del-problemas" class="md-nav__link">
    Análisis del Problemas
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#diseno-de-algoritmos_1" class="md-nav__link">
    Diseño de Algoritmos
  </a>
  
    <nav class="md-nav" aria-label="Diseño de Algoritmos">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#escritura-de-un-algoritmo" class="md-nav__link">
    Escritura de un Algoritmo
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#representacion-grafica-de-un-algoritmo" class="md-nav__link">
    Representación Gráfica de un Algoritmo
  </a>
  
    <nav class="md-nav" aria-label="Representación Gráfica de un Algoritmo">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#diagrama-de-flujo" class="md-nav__link">
    Diagrama de Flujo
  </a>
  
    <nav class="md-nav" aria-label="Diagrama de Flujo">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#simbolos-basicos" class="md-nav__link">
    Símbolos Básicos
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#simbolos-extras" class="md-nav__link">
    Símbolos Extras
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
          <li class="md-nav__item">
  <a href="#pseudocodigo" class="md-nav__link">
    Pseudocódigo
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#software" class="md-nav__link">
    software
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
                  </div>
                </div>
              </div>
            
          
          <div class="md-content" data-md-component="content">
            <article class="md-content__inner md-typeset">
              
                


<h1 id="diseno-de-algoritmos">Diseño de Algoritmos</h1>
<p>De manera sencilla, podemos decir que un algoritmo es un método que se emplea para obtener resultados a partir de los datos disponibles. En el capítulo xx se presenta con mayor detalle este concepto.</p>
<h2 id="resolucion-de-problemas">Resolución de Problemas</h2>
<p>Las etapas principales de resolución de problemas son:</p>
<ol>
<li>Análisis del problemas</li>
<li>Diseño o desarrollo de algoritmos</li>
<li>Resolución del algoritmo en el computador</li>
</ol>
<h2 id="analisis-del-problemas">Análisis del Problemas</h2>
<p>El análisis del problema exige una lectura previa del problema a fin de obtener una idea general de lo que se solicita. La segunda lectura deberá servir para responder a las preguntas:</p>
<ul>
<li>¿Qué información debe proporcionar la resolución del problema? (<strong>salidas</strong>)</li>
<li>¿Qué datos se necesitan para resolver el problema? (<strong>entradas</strong>)</li>
</ul>
<p><img alt="analisis" src="../analisis.png" /></p>
<h2 id="diseno-de-algoritmos_1">Diseño de Algoritmos</h2>
<p>Los problemas complejos se pueden resolver más eficazmente con el computador cuando se dividen en subprogramas que sean más faciles de solucionar que el original. Este método se suele denominar "divide y venceras", y consiste en dividir un problema complejo en otros más simples.</p>
<p>La descomposición del problema original en subproblemas más simples y a continuación dividir estos en subproblemas en otros más simples que pueden ser implementados para la solución del problema  presentado mediante un computador se denomina "diseño decendente" (top to down). Normalmente los pasos diseñados en un primer esbozo del algoritmo son incompletos e indicarán sólo unos pocos pasos de la solución, por lo que será necesario seguir refinando hasta llegar a una solución completa. Este proceso se llama "Refinamiento del algoritmo" o "Refinamiento por pasos".</p>
<p>Las ventajas más importantes del diseño descendente son:</p>
<ul>
<li>Es más fácil comprender un problema al dividirlo en partes más simples (subproblemas).</li>
<li>La modificación de un subproblema es más fácil que en todo el problema.</li>
<li>Se puede verificar si la solución es correcta de manera más fácil.</li>
</ul>
<p>Tras los pasos anteriores, (diseño descendente y refinamiento por pasos) se requerirá representar el algoritmo mediante una determinada herramienta de programación: diagrama de flujos y seudocódigo.</p>
<p><img alt="algoritmo" src="../disenodecendente.png" /></p>
<h3 id="escritura-de-un-algoritmo">Escritura de un Algoritmo</h3>
<p>Como ya se ha mencionado anteriormente, un algoritmo consiste en una secuencia de pasos descrita en
lenguaje natural. Específicamente, un algoritmo es un método o conjunto de reglas para solucionar un
problema. Estas reglas tienen las siguientes características:
Deben estar seguidas de alguna secuencia definida de pasos hasta que se obtenga un resultado coherente, Sólo puede ejecutarse un paso (instrucción) a la vez.
El flujo de control comúnmente es secuencial.</p>
<h3 id="representacion-grafica-de-un-algoritmo">Representación Gráfica de un Algoritmo</h3>
<h4 id="diagrama-de-flujo">Diagrama de Flujo</h4>
<p>Un diagrama de flujo es una de las técnicas de representación de algoritmos más conocida y utilizada, aunque su empleo ha disminuido considerablemente, sobre todo desde la aparición de lenguajes de programación estructurados.</p>
<h5 id="simbolos-basicos">Símbolos Básicos</h5>
<table>
<thead>
<tr>
<th>Nombre</th>
<th align="center">Definición</th>
<th align="right">Símbolos</th>
</tr>
</thead>
<tbody>
<tr>
<td>Inicio / Final</td>
<td align="center">El símbolo de terminación marca el punto inicial o final del sistema. Por lo general, contiene la palabra "Inicio" o "Fin".</td>
<td align="right"><img alt="inicio" src="../diagrama/start-end-symbol.jpg" /></td>
</tr>
<tr>
<td>Entrada / Salida</td>
<td align="center">Representa el material o la información que entra o sale del sistema, como una orden del cliente (entrada) o un producto (salida).</td>
<td align="right"><img alt="entrada" src="../diagrama/input-output-symbol.jpg" /></td>
</tr>
<tr>
<td>Proceso</td>
<td align="center">Un rectangulo solo puede representar un solo paso dentro de un processo ("agregar dos tazas de harina"), o un subproceso completo ("hacer pan") dentro de un proceso más grande.</td>
<td align="right"><img alt="Proceso" src="../diagrama/action-process-symbol.jpg" /></td>
</tr>
<tr>
<td>Decisión o Ramificación</td>
<td align="center">Un punto de decisión o ramificación. Las líneas que representan diferentes decisiones surgen de diferentes puntos del diamante.</td>
<td align="right"><img alt="decisión" src="../diagrama/decision-symbol.jpg" /></td>
</tr>
<tr>
<td>Conector</td>
<td align="center">Indica que el flujo continúa donde se ha colocado un símbolo identico (que contiene la misma letra).</td>
<td align="right"><img alt="Conector" src="../diagrama/connector-symbol.jpg" /></td>
</tr>
<tr>
<td>Entrada Manual</td>
<td align="center">Representa un paso en el que se pide al usuario que introduzca la información manualmente.</td>
<td align="right"><img alt="entrada" src="../diagrama/manual-input-symbol.jpg" /></td>
</tr>
<tr>
<td>Visualización</td>
<td align="center">Indica un paso que muestra información.</td>
<td align="right"><img alt="visualización" src="../diagrama/display-symbol.jpg" /></td>
</tr>
</tbody>
</table>
<h5 id="simbolos-extras">Símbolos Extras</h5>
<table>
<thead>
<tr>
<th>Nombre</th>
<th align="center">Definición</th>
<th align="right">Símbolos</th>
</tr>
</thead>
<tbody>
<tr>
<td>Documento</td>
<td align="center">Un documento o informe impreso.</td>
<td align="right"><img alt="Documento" src="../diagrama/document-symbol.jpg" /></td>
</tr>
<tr>
<td>Multidocumento</td>
<td align="center">Representa multidocumento en el proceso.</td>
<td align="right"><img alt="Multidocumento" src="../diagrama/multiple-documents-symbol.jpg" /></td>
</tr>
<tr>
<td>Preparación</td>
<td align="center">Representa un ajuste a otro paso en el proceso.</td>
<td align="right"><img alt="Preparación" src="../diagrama/preparation-symbol.jpg" /></td>
</tr>
<tr>
<td>O Símbolo</td>
<td align="center">Indica que el flujo del proceso continúa en más de dos ramas.</td>
<td align="right"><img alt="O" src="../diagrama/or-symbol.jpg" /></td>
</tr>
<tr>
<td>Union de Invocación</td>
<td align="center">Indica un punto en el diagrama de flujo en el que múltiples ramificaciones convergen de nuevo en un solo proceso.</td>
<td align="right"><img alt="Union" src="../diagrama/summoning-junction-symbol.jpg" /></td>
</tr>
<tr>
<td>Fusión</td>
<td align="center">Indica un punto en el diagrama de flujo en el que múltiples ramificaciones convergen de nuevo en un solo proceso.</td>
<td align="right"><img alt="fusion" src="../diagrama/merge-symbol.jpg" /></td>
</tr>
<tr>
<td>Intercalar</td>
<td align="center">Indica un paso que ordena información en un formato estándar.</td>
<td align="right"><img alt="Intercalar" src="../diagrama/collate-symbol.jpg" /></td>
</tr>
<tr>
<td>Ordenar</td>
<td align="center">Indica un paso que organiza una lista de elementos en una secuencia o establece según algunos criterios predeterminados.</td>
<td align="right"><img alt="Ordenar" src="../diagrama/sort-symbol.jpg" /></td>
</tr>
<tr>
<td>Proceso Predefinido</td>
<td align="center">Indica una secuencia de acciones que realizan una tarea específica incrustada dentro de un proceso más grande. Esta secuencia de acciones podría describirse con más detalle en un diagrama de flujo separado.</td>
<td align="right"><img alt="Procesos" src="../diagrama/subroutine-symbol.jpg" /></td>
</tr>
<tr>
<td>Operación manual</td>
<td align="center">Indica una secuencia de comandos que continuarán repitiéndose hasta que se detenga manualmente.</td>
<td align="right"><img alt="Operación manual" src="../diagrama/manual-loop-symbol.jpg" /></td>
</tr>
<tr>
<td>Bucle</td>
<td align="center">Indica el punto en el que debe detenerse un bucle.</td>
<td align="right"><img alt="bucle" src="../diagrama/loop-limit-symbol.jpg" /></td>
</tr>
<tr>
<td>Retardo</td>
<td align="center">Indica un retraso en el proceso.</td>
<td align="right"><img alt="Retardo" src="../diagrama/delay-symbol.jpg" /></td>
</tr>
<tr>
<td>Almacenamiento de datos</td>
<td align="center">Indica un paso donde se almacenan los datos.</td>
<td align="right"><img alt="Almacenamiento" src="../diagrama/data-storage-symbol.jpg" /></td>
</tr>
<tr>
<td>Base de Datos</td>
<td align="center">Indica una lista de información con una estructura estándar que permite buscar y ordenar.</td>
<td align="right"><img alt="BD" src="../diagrama/database-symbol.jpg" /></td>
</tr>
<tr>
<td>Almacenamiento interno</td>
<td align="center">Indica que la información se almacenó en la memoria durante un programa, utilizado en diagramas de flujo de diseño de software.</td>
<td align="right"><img alt="Almacenamiento" src="../diagrama/internal-storage-symbol.jpg" /></td>
</tr>
<tr>
<td>Conector fuera de  página</td>
<td align="center">Indica que el proceso continúa fuera de la página.</td>
<td align="right"><img alt="Conector" src="../diagrama/off-page-symbol.jpg" /></td>
</tr>
</tbody>
</table>
<h4 id="pseudocodigo">Pseudocódigo</h4>
<p>El seudocódigo es un lenguaje de especificación (descripción) de algoritmos. La finalidad de este lenguaje es hacer más fácil la traducción del diseño del algoritmo en un lenguaje de programación específico.
La ventaja del seudocódigo es que el programador se puede concentrar en la lógica y en las estructuras de control y no preocuparse de las reglas de un lenguaje de programación específico. Otra ventaja, es que es fácil modificar un algoritmo en caso en encontrar errores.</p>
<table>
<thead>
<tr>
<th>Palabra Reservada</th>
<th align="center">Función</th>
<th align="right">ejemplo</th>
</tr>
</thead>
<tbody>
<tr>
<td>Leer, Ingresar, Introducir</td>
<td align="center">Estos son algunos ejemplos de palabras reservadas para ingresar datos en una variable</td>
<td align="right">Leer numero</td>
</tr>
<tr>
<td>si-sino</td>
<td align="center">Se utilizan para especificar una condición lógica</td>
<td align="right">Si (numero &gt;10)</td>
</tr>
<tr>
<td>Mientras, Hacer Mientras</td>
<td align="center">Se utilizan para indicar que hay instrucciones que se deben ejecutar más de una vez</td>
<td align="right">Mientras ( numero &gt;0)</td>
</tr>
<tr>
<td>Asignar <img alt="flecha" src="../diagrama/flecha.png" /></td>
<td align="center">La flecha se utiliza para asignar un dato a una variable</td>
<td align="right">Numero &lt;- 20</td>
</tr>
<tr>
<td>Escribir, mostrar, Imprimir</td>
<td align="center">Estos son algunos ejemplos de palabras reservadas para mostrar un dato o una frase por pantalla</td>
<td align="right">Escribir numero</td>
</tr>
</tbody>
</table>
<h4 id="software">software</h4>
<ol>
<li>Diagramas de flujo<ul>
<li><a href="https://freedfd.en.uptodown.com/windows">FreeDFD</a></li>
<li><a href="https://miro.com/templates/data-flow-diagram/">Miro</a></li>
</ul>
</li>
<li>PSeudocodigo<ul>
<li><a href="http://pseint.sourceforge.net/">PseInt</a></li>
</ul>
</li>
<li>Otros tipos de diagramas<ul>
<li><a href="http://staruml.io/">StarUML</a></li>
<li><a href="https://www.visual-paradigm.com/">Visual Paradigm</a></li>
<li><a href="http://dia-installer.de/">Dia</a></li>
</ul>
</li>
</ol>

              
            </article>
            
  <script>var tabs=__md_get("__tabs");if(Array.isArray(tabs))e:for(var set of document.querySelectorAll(".tabbed-set")){var tab,labels=set.querySelector(".tabbed-labels");for(tab of tabs)for(var label of labels.getElementsByTagName("label"))if(label.innerText.trim()===tab){var input=document.getElementById(label.htmlFor);input.checked=!0;continue e}}</script>

          </div>
        </div>
        
      </main>
      
        <footer class="md-footer">
  
    
    <nav class="md-footer__inner md-grid" aria-label="Pie" >
      
        
        <a href="../conceptos/" class="md-footer__link md-footer__link--prev" aria-label="Anterior: Conceptos de Programación" rel="prev">
          <div class="md-footer__button md-icon">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
          </div>
          <div class="md-footer__title">
            <div class="md-ellipsis">
              <span class="md-footer__direction">
                Anterior
              </span>
              Conceptos de Programación
            </div>
          </div>
        </a>
      
      
        
        <a href="../EstructurasControl/" class="md-footer__link md-footer__link--next" aria-label="Siguiente: Estructuras de Control" rel="next">
          <div class="md-footer__title">
            <div class="md-ellipsis">
              <span class="md-footer__direction">
                Siguiente
              </span>
              Estructuras de Control
            </div>
          </div>
          <div class="md-footer__button md-icon">
            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M4 11v2h12l-5.5 5.5 1.42 1.42L19.84 12l-7.92-7.92L10.5 5.5 16 11H4Z"/></svg>
          </div>
        </a>
      
    </nav>
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
    <div class="md-copyright__highlight">
      Copyright &copy; 2022 Francisco Escobar
    </div>
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    <script id="__config" type="application/json">{"base": "../..", "features": ["content.tabs.link"], "search": "../../assets/javascripts/workers/search.b97dbffb.min.js", "translations": {"clipboard.copied": "Copiado al portapapeles", "clipboard.copy": "Copiar al portapapeles", "search.config.lang": "es", "search.config.pipeline": "trimmer, stopWordFilter", "search.config.separator": "[\\s\\-]+", "search.placeholder": "B\u00fasqueda", "search.result.more.one": "1 m\u00e1s en esta p\u00e1gina", "search.result.more.other": "# m\u00e1s en esta p\u00e1gina", "search.result.none": "No se encontraron documentos", "search.result.one": "1 documento encontrado", "search.result.other": "# documentos encontrados", "search.result.placeholder": "Teclee para comenzar b\u00fasqueda", "search.result.term.missing": "Falta", "select.version.title": "Seleccionar versi\u00f3n"}}</script>
    
    
      <script src="../../assets/javascripts/bundle.6c7ad80a.min.js"></script>
      
    
  </body>
</html>